#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "bch.h"

int L, N, *pmt, *pmt2;
char *mdl, *lbl, *bit;

inline void parseArgs(int argc, char *argv[]) {
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			mdl = argv[i];
		}
		else if(strcmp(argv[i], "-label") == 0 && i+1 < argc) {
			++i;
			lbl = argv[i];
		}
		else if(strcmp(argv[i], "-bits") == 0 && i+1 < argc) {
			++i;
			bit = argv[i];
		}
	}
	assert(mdl != NULL && lbl != NULL && bit != NULL);
}

int main(int argc, char *argv[])
{
	int i, t;

	parseArgs(argc, argv);

	FILE *fp = fopen(mdl, "r");
	fscanf(fp, "%d %d %d", &N, &L, &t);

	BchCoder *coder = new BchCoder();
	coder->init(L, t);
	int k = coder->getK();

	pmt = (int*)malloc(sizeof(int)*k);
	pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < k; ++i)
		fscanf(fp, "%d", &pmt[i]);
	for(i = 0; i < L; ++i)
		fscanf(fp, "%d", &pmt2[i]);
	fclose(fp);

	char *s, *s2, *ptr;
	s = (char*)malloc(sizeof(char)*(N+3));
	s2 = (char*)malloc(sizeof(char)*(L*30+3));
	int *code, *label;
	code = (int*)malloc(sizeof(int)*(L+3));

	FILE *flbl = fopen(lbl, "w");
	FILE *fbit = fopen(bit, "r");
	while(fgets(s2, L*30+2, fbit) != NULL) {
		for(i = 0, ptr = strtok(s2, " "); ptr != NULL && i < L; ++i, ptr = strtok(NULL, " ")) {
			double val;
			sscanf(ptr, "%lf", &val);
			if(val != 0.5) code[pmt2[i]] = (val>0.5) ? 1 : 0;
			else code[pmt2[i]] = rand() & 1;
		}
		label = coder->decode(code, L);
		for(i = 0; i < k; ++i)
			if(pmt[i] != -1)
				s[pmt[i]] = '0' + label[i];
		s[N] = '\n';
		s[N+1] = '\0';
		fputs(s, flbl);
	}
	fclose(flbl);
	fclose(fbit);
}
