#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "bch.h"

int L, N, *pmt, *pmt2;
char *mdl, *lbl, *bit;

inline void parseArgs(int argc, char *argv[]) {
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			mdl = argv[i];
		}
		else if(strcmp(argv[i], "-label") == 0 && i+1 < argc) {
			++i;
			lbl = argv[i];
		}
		else if(strcmp(argv[i], "-bits") == 0 && i+1 < argc) {
			++i;
			bit = argv[i];
		}
	}
	assert(mdl != NULL && lbl != NULL && bit != NULL);
}

int main(int argc, char *argv[])
{
	int i, t;

	parseArgs(argc, argv);

	FILE *fp = fopen(mdl, "r");
	fscanf(fp, "%d %d %d", &N, &L, &t);

	BchCoder bch;
	bch.init(L, t);
	int k = bch.getK();

	pmt = (int*)malloc(sizeof(int)*k);
	pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < k; ++i)
		fscanf(fp, "%d", &pmt[i]);
	for(i = 0; i < L; ++i)
		fscanf(fp, "%d", &pmt2[i]);
	fclose(fp);

	char *s = (char*)malloc(sizeof(char)*(k+3));
	char *s2 = (char*)malloc(sizeof(char)*(L+3));
	int *data = (int*)malloc(sizeof(int)*(k+3));

	FILE *flbl = fopen(lbl, "r");
	FILE *fbit = fopen(bit, "w");
	fprintf(fbit, "%d %d\n", N, L);
	while(fgets(s, k+2, flbl) != NULL) {
		for(i = 0; i < k; ++i)
			data[i] = (pmt[i]!=-1) ? s[pmt[i]]-'0' : 0;
		int *recd = bch.encode(data);
		for(i = 0; i < L; ++i)
			s2[i] = '0' + recd[pmt2[i]];
		s2[L] = '\n';
		s2[L+1] = '\0';
		fputs(s2, fbit);
	}
	fclose(flbl);
	fclose(fbit);
}

