#include <assert.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include "bch.h"

int L, N;
char *model;

inline void parseArgs(int argc, char *argv[]) {
	srand(time(NULL));
        for(int i = 1; i < argc; ++i) {
                if(strcmp(argv[i], "-l") == 0 && i+1 < argc) {
                        ++i;
                        sscanf(argv[i], "%d", &L);
                }
                else if(strcmp(argv[i], "-n") == 0 && i+1 < argc) {
                        ++i;
                        sscanf(argv[i], "%d", &N);
                }
                else if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
                        ++i;
                        model = argv[i];
                }
		else if(strcmp(argv[i], "-seed") == 0 && i+1 < argc) {
			++i;
			unsigned int seed;
			sscanf(argv[i], "%x", &seed);
			srand(seed);
		}
        }
        assert(L != -1); assert(N != -1); assert(model != NULL);
        assert(N <= L);
	printf("N = %d, L = %d\n", N, L);
}

int main(int argc, char *argv[])
{
	int             i;

	parseArgs(argc, argv);
	BchCoder bch;
	bch.initK(L, N);
	int t = bch.getT(), k = bch.getK();

	FILE *fp = fopen(model, "w");
	fprintf(fp, "%d %d %d\n", N, L, t);

	int *pmt = (int*)malloc(sizeof(int)*k);
	for(i = 0; i < k; ++i) pmt[i] = i;
	for(i = 0; i < k; ++i)
	{
		int j = rand() % k;
		int t = pmt[i];
		pmt[i] = pmt[j];
		pmt[j] = t;
	}
	int *pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < L; ++i) pmt2[i] = i;
	for(i = 0; i < L; ++i)
	{
		int j = rand() % L;
		int t = pmt2[i];
		pmt2[i] = pmt2[j];
		pmt2[j] = t;
	}
	for(i = 0; i < k; ++i)
		fprintf(fp, "%d ", (pmt[i]<N)?pmt[i]:-1);
	fprintf(fp, "\n");
	for(i = 0; i < L; ++i)
		fprintf(fp, "%d ", pmt2[i]);
	fprintf(fp, "\n");

	fclose(fp);
}
