#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <vector>
using namespace std;

#include "bch.h"
#include "solver.h"
#include "util.h"

int L, N, *pmt, *pmt2;
char *mdlIn, *mdlOut;

inline void parseArgs(int argc, char *argv[]) {
	mdlIn = argv[1];
	mdlOut = argv[2];
	assert(mdlIn != NULL && mdlOut != NULL);
}

int main(int argc, char *argv[]) {
	int i, t;
	setRandSeed();
	parseArgs(argc, argv);

	FILE *fp = fopen(mdlIn, "r");
	assert(fp != NULL);
	fscanf(fp, "%d %d %d", &N, &L, &t);

	BchCoder coder;
	coder.init(L, t);
	int n2 = coder.getK();

	pmt = (int*)malloc(sizeof(int)*n2);
	pmt2 = (int*)malloc(sizeof(int)*L);
	int *pmti = (int*)malloc(sizeof(int)*n2);
	int *pmt2i = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < n2; ++i) {
		fscanf(fp, "%d", &pmt[i]);
		if(pmt[i] != -1) pmti[pmt[i]] = i;
	}
	for(i = 0; i < L; ++i) {
		fscanf(fp, "%d", &pmt2[i]);
		pmt2i[pmt2[i]] = i;
	}
	fclose(fp);

	int *code, *label;
	label = (int*)malloc(sizeof(int)*(L+3));
	vector<vector<int> > code2label(L, vector<int>(N,0));
	for(int i = 0; i < N; ++i) {
		for(int j = 0; j < n2; ++j) label[j] = (j==pmti[i]) ? 1 : 0;
		code = coder.encode(label);
		for(int j = 0; j < L; ++j)
			if(code[j] == 1) {
				int jj = pmt2i[j];
				code2label[jj][i] = 1;
			}
	}

	fp = fopen(mdlOut, "w");
	fprintf(fp, "%d %d\n", N, L);
	for(int i = 0; i < L; ++i) {
		for(int j = 0; j < N; ++j)
			fprintf(fp, code2label[i][j]?"1":"0");
		fprintf(fp, "\n");
	}
	fclose(fp);
}


