#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "util.h"

int L, N, *pmt, *pmt2;
int wrong_bit[] = {-1, 6, 5, 3, 4, 2, 0, 1};
char *mdl, *lbl, *bit;

inline void parseArgs(int argc, char *argv[]) {
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			mdl = argv[i];
		}
		else if(strcmp(argv[i], "-label") == 0 && i+1 < argc) {
			++i;
			lbl = argv[i];
		}
		else if(strcmp(argv[i], "-bits") == 0 && i+1 < argc) {
			++i;
			bit = argv[i];
		}
	}
	assert(mdl != NULL && lbl != NULL && bit != NULL);
}

int main(int argc, char *argv[])
{
	int i, j, k, m, nham;

	parseArgs(argc, argv);
	setRandSeed();

	FILE *fp = fopen(mdl, "r");
	fscanf(fp, "%d %d", &N, &L);
	nham = L / 7;
	m = nham*4 + (L%7);

	pmt = (int*)malloc(sizeof(int)*m);
	pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < m; ++i)
		fscanf(fp, "%d", &pmt[i]);
	for(i = 0; i < L; ++i)
		fscanf(fp, "%d", &pmt2[i]);
	fclose(fp);

	char *s, *s2, *p;
	int *vote;
	double *val;
	s = (char*)malloc(sizeof(char)*(N+3));
	s2 = (char*)malloc(sizeof(char)*(L*30+3));
	vote = (int*)malloc(sizeof(int)*(N+3));
	val = (double*)malloc(sizeof(double)*(L+3));

	FILE *flbl = fopen(lbl, "w");
	FILE *fbit = fopen(bit, "r");
	while(fgets(s2, L*30+2, fbit) != NULL) {
		for(i = 0; i < N; ++i) vote[i] = 0;
		for(i = 0, p = strtok(s2, " "); p != NULL && i < L; ++i, p = strtok(NULL, " "))
			sscanf(p, "%lf", &val[pmt2[i]]);
		assert(i == L);
		assert(p == NULL);
		//decode the hamming part (first (N/7)*7 bits)
		for(i = j = k = 0; i < nham; ++i, j += 7, k += 4) {
			char b[8];
			for(m = 0; m < 7; ++m) {
				if(val[j+m] != 0.5) b[m] = (val[j+m]>0.5) ? 1 : 0;
				else b[m] = (rand()&1) ? 1 : 0;
			}
			int check = 0;
			check |= (b[0] ^ b[1] ^ b[2] ^ b[4]) ? 4 : 0;	// 0,1,2
			check |= (b[0] ^ b[1] ^ b[3] ^ b[5]) ? 2 : 0;	// 0,1,3
			check |= (b[1] ^ b[2] ^ b[3] ^ b[6]) ? 1 : 0;	// 1,2,3
			if(wrong_bit[check] >= 0)
				b[wrong_bit[check]] ^= 1;	// correct single bit error
			vote[pmt[k]] += (b[0]==1) ? 1 : -1;
			vote[pmt[k+1]] += (b[1]==1) ? 1 : -1;
			vote[pmt[k+2]] += (b[2]==1) ? 1 : -1;
			vote[pmt[k+3]] += (b[3]==1) ? 1 : -1;
		}
  		
		//decode the remaining part by repetition code (last (N % 7) bits)
		for(; j < L; ++j, ++k) {
			if(val[j] != 0.5) vote[pmt[k]] += (val[j]>0.5) ? 1 : -1;
		}

		for(i = 0; i < N; ++i) {
			if(vote[i] != 0) s[i] = (vote[i]>0) ? '1' : '0';
			else s[i] = (rand()&1) ? '1' : '0';
		}
                s[N] = '\n';
                s[N+1] = '\0';
                fputs(s, flbl);
	}
	fclose(flbl);
	fclose(fbit);
}

