#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int L, N, *pmt, *pmt2;
char *mdl, *lbl, *bit;

inline void parseArgs(int argc, char *argv[]) {
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			mdl = argv[i];
		}
		else if(strcmp(argv[i], "-label") == 0 && i+1 < argc) {
			++i;
			lbl = argv[i];
		}
		else if(strcmp(argv[i], "-bits") == 0 && i+1 < argc) {
			++i;
			bit = argv[i];
		}
	}
	assert(mdl != NULL && lbl != NULL && bit != NULL);
}

int main(int argc, char *argv[])
{
	int i, j, k, m, nham;

	parseArgs(argc, argv);

	FILE *fp = fopen(mdl, "r");
	fscanf(fp, "%d %d", &N, &L);
	nham = L / 7;
	m = nham*4 + (L%7);

	pmt = (int*)malloc(sizeof(int)*m);
	pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < m; ++i)
		fscanf(fp, "%d", &pmt[i]);
	for(i = 0; i < L; ++i)
		if(fscanf(fp, "%d", &pmt2[i]) != 1) break;
	if(i < L) for(i = 0; i < L; ++i) pmt2[i] = i;
	fclose(fp);

	char *s, *s2, *s3;
	s = (char*)malloc(sizeof(char)*(N+5));
	s2 = (char*)malloc(sizeof(char)*(L+5));
	s3 = (char*)malloc(sizeof(char)*(L+3));

	FILE *flbl = fopen(lbl, "r");
	FILE *fbit = fopen(bit, "w");
	fprintf(fbit, "%d %d\n", N, L);
	while(fgets(s, N+4, flbl) != NULL) {
  		//encode the hamming part (first (N/7)*7 bits)
		for(i = j = k = 0; i < nham; ++i, j += 7, k += 4) {
			s2[j] = s[pmt[k]];
			s2[j+1] = s[pmt[k+1]];
			s2[j+2] = s[pmt[k+2]];
			s2[j+3] = s[pmt[k+3]];
			s2[j+4] = s2[j] ^ s2[j+1] ^ s2[j+2];	// 0,1,2
			s2[j+5] = s2[j] ^ s2[j+1] ^ s2[j+3];	// 0,1,3
			s2[j+6] = s2[j+1] ^ s2[j+2] ^ s2[j+3];	// 1,2,3
		}
  		//encode the remaining part by repetition code (last (N % 7) bits)
		for(; j < L; ++j, ++k)
			s2[j] = s[pmt[k]];

		for(i = 0; i < L; ++i)
			s3[i] =s2[pmt2[i]];
                s3[L] = '\n';
                s3[L+1] = '\0';
                fputs(s3, fbit);
	}
	fclose(flbl);
	fclose(fbit);
}

