#include<assert.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>

int L, N;
char *model;

inline void parseArgs(int argc, char *argv[]) {
	srand(time(NULL));
        for(int i = 1; i < argc; ++i) {
                if(strcmp(argv[i], "-l") == 0 && i+1 < argc) {
                        ++i;
                        sscanf(argv[i], "%d", &L);
                }
                else if(strcmp(argv[i], "-n") == 0 && i+1 < argc) {
                        ++i;
                        sscanf(argv[i], "%d", &N);
                }
                else if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
                        ++i;
                        model = argv[i];
                }
		else if(strcmp(argv[i], "-seed") == 0 && i+1 < argc) {
			++i;
			unsigned int seed;
			sscanf(argv[i], "%x", &seed);
			srand(seed);
		}
        }
        assert(L != -1); assert(N != -1); assert(model != NULL);
        assert(N <= L);
}

void randperm(int *a, int n) {
	for(int i = 0; i < n; ++i) {
		int j = rand()%n;
		int t = a[i];
		a[i] = a[j];
		a[j] = t;
	}
}

int main(int argc, char *argv[]) {
	int i, j, m, n, r, t;

	parseArgs(argc, argv);
	FILE *fp = fopen(model, "w");
	fprintf(fp, "%d %d\n", N, L);

	int *pmt = (int*)malloc(sizeof(int)*N);
	for(i = 0; i < N; ++i) pmt[i] = i;
	m = (L/7)*4 + (L%7);
	n = N - (N&3);
	r = 0;
	for(i = 0; i < m; ) {
		for(j = 0; j < r; ++j) {
			t = pmt[N-r+j];
			pmt[N-r+j] = pmt[j];
			pmt[j] = t;
		}
		randperm(pmt+r, N-r);
		for(j = 0; j+4 <= N;) {
			if(i+j >= m) break;
			fprintf(fp, "%d ", pmt[j++]);
			if(i+j >= m) break;
			fprintf(fp, "%d ", pmt[j++]);
			if(i+j >= m) break;
			fprintf(fp, "%d ", pmt[j++]);
			if(i+j >= m) break;
			fprintf(fp, "%d ", pmt[j++]);
		}
		i += j;
		r = N - j;
	}
	fprintf(fp, "\n");

	int *pmt2 = (int*)malloc(sizeof(int)*L);
	for(i = 0; i < L; ++i) pmt2[i] = i;
	randperm(pmt2, L);
	for(i = 0; i < L; ++i)
		fprintf(fp, "%d ", pmt2[i]);
	fprintf(fp, "\n");
}
