#include<assert.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>

int L = -1, N = -1, cpc = 8;
char *cm = NULL;
char path[64] = " ./coder/LDPC-codes-2012-02-11";

inline void parseArgs(int argc, char *argv[]) {
	srand(time(NULL));
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-l") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &L);
		}
		else if(strcmp(argv[i], "-n") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &N);
		}
		else if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			cm = argv[i];
		}
		else if(strcmp(argv[i], "-cpc") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &cpc);
		}
		else if(strcmp(argv[i], "-seed") == 0 && i+1 < argc) {
			++i;
			unsigned int seed;
			sscanf(argv[i], "%x", &seed);
			srand(seed);
		}
	}
	assert(L != -1); assert(N != -1); assert(cpc >= 2);
	assert(N <= L);
}

int main(int argc, char *argv[]) {
	char cmd[1024];
	parseArgs(argc, argv);
	FILE *fp = fopen(cm, "w");
	fprintf(fp, "%d %d\n", N, L);
	fclose(fp);
	sprintf(cmd, "%s/make-ldpc %s.pchk %d %d %d evenboth %d", path, cm, L-N, L, rand()%1000000, cpc);
	system(cmd);
	sprintf(cmd, "%s/pchk-to-alist %s.pchk - >> %s", path, cm, cm);
	system(cmd);
	sprintf(cmd, "rm %s.pchk", cm);
	system(cmd);
}

