#include<assert.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>
#include<set>
#include<string>
using namespace std;

int L = -1, N = -1, K, *A, *S;
char *cm = NULL;
FILE *fp;
set<string> C;

inline void parseArgs(int argc, char *argv[]) {
	srand(time(NULL));
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-l") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &L);
		}
		else if(strcmp(argv[i], "-n") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &N);
		}
		else if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			cm = argv[i];
		}
		else if(strcmp(argv[i], "-k") == 0 && i+1 < argc) {
			++i;
			sscanf(argv[i], "%d", &K);
		}
		else if(strcmp(argv[i], "-seed") == 0 && i+1 < argc) {
			++i;
			unsigned int seed;
			sscanf(argv[i], "%x", &seed);
			srand(seed);
		}
	}
	assert(L != -1); assert(N != -1); assert(cm != NULL);
	assert(N <= L);
	assert(K <= N);
	fp = fopen(cm, "w");
}

int main(int argc, char *argv[]) {
	int i, j, k, t;
	parseArgs(argc, argv);
	A = (int*)malloc(sizeof(int)*L);
	char *select = (char*)malloc(sizeof(char)*(N+1));

	long long cmb = N;
	for(i = 2; i <= K; ++i) {
		if(cmb%i == 0) cmb = (cmb/i) * (N-i+1);
		else cmb *= (N-i+1) / i;
		if(cmb > 0x7fffffff) break;
	}
START:
	i = 0;
	t = L/K;
	do {
		for(; i < t && C.size() < cmb; ++i) {
			memset(select, '0', sizeof(char)*N);
			for(j = 0; j < K; ++j) {
				k = rand() % N;
				if(select[k] == '1') --j;
				else select[k] = '1';
			}
			select[N] = '\0';
			if(C.find(string(select)) != C.end()) --i;
			else {
				C.insert(string(select));
				for(j = 0, k = i*K; j < N; ++j)
					if(select[j] == '1') A[k++] = j;
			}
		}
		C.clear();
	}while(i < t);
	if(L > t*K) {
		memset(select, '0', sizeof(char)*N);
		for(j = 0; j < L-t*K; ++j) {
			k = rand() % N;
			if(select[k] == '1') --j;
			else select[k] = '1';
		}
		for(j = 0, k = t*K; j < N; ++j)
			if(select[j] == '1') A[k++] = j;
	}
	for(j = 0; j < N; ++j) select[j] = 0;
	for(i = 0; i < L; ++i) select[A[i]] = 1;
	for(j = 0; j < N; ++j)
		if(select[j] == 0) break;
	if(j < N) goto START;


	fprintf(fp, "%d %d\n", N, L);
	for(i = 0; i < L; ++i) {
		fprintf(fp, "%d ", A[i]);
	}
	fprintf(fp, "\n");
}

