#include<assert.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<time.h>

#include"linear.h"
/* train.c will define the following:
	struct parameter param;		// set by parse_command_line
	struct problem prob;		// set by read_problem
	struct model *model_;
*/
#define main never_be_called
#include"train.c"
#undef main

char *bit_path;

// set by readModel
int N, L, nModel;
char **base_model_path, *bits;
int *nPos, **bit_pos;

void readModel(char *model_path) {
	FILE *fp = fopen(model_path, "r");
	assert(fp != NULL);
	fscanf(fp, "%d %d %d", &N, &L, &nModel);
	base_model_path = (char**)malloc(sizeof(char*)*nModel);
	bit_pos = (int**)malloc(sizeof(int*)*nModel);
	nPos = (int*)malloc(sizeof(int)*nModel);
	for(int i = 0; i < nModel; ++i) {
		base_model_path[i] = (char*)malloc(sizeof(char)*4096);
		fscanf(fp, "%s %d", base_model_path[i], &nPos[i]);
		bit_pos[i] = (int*)malloc(sizeof(int)*nPos[i]);
		for(int j = 0; j < nPos[i]; ++j)
			fscanf(fp, "%d", bit_pos[i]+j);
	}
	fclose(fp);
}

void parseArgs(int argc, char *argv[]) {
	char datafile[4096], *modelfile = NULL;
	for(int i = 1; i < argc; ++i) {
		if(strcmp(argv[i], "-data") == 0 && i+1 < argc) {
			++i;
			//datafile = argv[i];
			strcpy(datafile, argv[i]);
			strcat(datafile, ".svm");
		}
		else if(strcmp(argv[i], "-model") == 0 && i+1 < argc) {
			++i;
			modelfile = argv[i];
		}
		else if(strcmp(argv[i], "-bit") == 0 && i+1 < argc) {
			++i;
			bit_path = argv[i];
		}
	}
	assert(datafile != NULL);
	assert(modelfile != NULL);
	assert(bit_path != NULL);
	bias = 1;
	read_problem(datafile);
	readModel(modelfile);
}

int main(int argc, char *argv[]) {
	parseArgs(argc, argv);

	int i, j, k;
	double *bits = (double*)malloc(sizeof(double)*prob.l*L);
	memset(bits, 0, sizeof(double)*prob.l*L);
	for(i = 0, j = 0; i < nModel; ++i)
		if(nPos[i] > j) j = nPos[i];
	double *p = (double*)malloc(sizeof(double)*(1<<j));

	FILE *fp = fopen(bit_path, "w");
	assert(fp != NULL);
	for(i = 0; i < nModel; ++i) {
		fprintf(fp, "=====");
		for(j = 0; j < nPos[i]; ++j)
			fprintf(fp, " %d", bit_pos[i][j]);
		fprintf(fp, " =====\n");
		model_ = load_model(base_model_path[i]);
		for(j = 0; j < prob.l; ++j) {
			double v = predict_probability(model_, prob.x[j], p);
			for(k = 0; k < (1<<nPos[i]); ++k) {
				v = 0.0;
				for(int x = 0; x < model_->nr_class; ++x)
					if(model_->label[x] == k) {
						v = p[x];
						break;
					}
				fprintf(fp, "%.6lf%c", v, (k+1==(1<<nPos[i]))?'\n':' ');
			}
		}
	}
	fclose(fp);
}


