import os
import random
import subprocess
import sys

random.seed()
DRY_RUN = False
COLOR_RED = 31
COLOR_YELLOW = 33
COLOR_WHITE = 37

def parseArgs(args):
	d = dict()
	for i in xrange(len(args)):
		if args[i][0] == '-':
			if i+1 == len(args) or args[i+1][0] == '-':
				d[args[i][1:]] = True
			else:
				d[args[i][1:]] = args[i+1]
	return d

def parseRanges(s):
	r = []
	for a in s.split(','):
		if a.rfind(':') == -1:
			r += [int(a)]
		else:
			x = map(int, a.split(':'))
			r += range(x[0], x[1]+1)
	return r

def wrapColor(s, c):
	if c == 0:
		return s
	else:
		return "\033[1;" + str(c) + "m" + s + "\033[0m"

def logColor(ls, clr):
	if not isinstance(ls, list):
		ls = [ls]
	if not isinstance(clr, list):
		clr = [clr]
	if len(clr) > len(ls):
		clr = clr[:len(ls)]
	elif len(clr) < len(ls):
		clr = clr + [ 0 for i in xrange(len(ls)-len(clr))]
	print " ".join(map(lambda (s,c): wrapColor(s, c), zip(ls, clr)))

def call(args):
	logColor(args, COLOR_WHITE)
	if not DRY_RUN:
		p = subprocess.Popen(args, stdout=sys.stdout, stderr=sys.stderr)
		r = p.wait()
#		r = subprocess.call(args)
		assert r == 0, wrapColor(str(args), COLOR_RED)

UPPER = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
LOWER = "abcdefghijklmnopqrstuvwxyz"
ALPHA = UPPER + LOWER
DIGIT = "0123456789"
ALPHANUM = ALPHA + DIGIT

def randString(l, alpha):
	return ''.join([ random.choice(alpha) for i in xrange(l) ])

def readLines(filename):
	return [ s.strip() for s in open(filename).readlines() ]

def avg(ls):
	return sum(ls) / float(len(ls))
